#pragma once

namespace saffron {

/**
 * @brief Error Code
 **
 **/
typedef enum {
    COORD_SUCCESS = 0,
    COORD_INVALID_PARAM = -1,
    // COORD_INVALID_DESC = -2,
    // memory allocation failed
    // COORD_ALLOC_MEMORY_FAILED = -3,
    COORD_INTERNAL_ERROR = -4,
    // doesn't support the image format
    // COORD_INVALID_PIXEL_FORMAT = -5,
    // the model file is not exist or has no read permission
    // COORD_FILE_NOT_FOUND = -6,
    // invalid model file format
    // COORD_INVALID_FILE_FORMAT = -7,
    // COORD_NOT_IMPLEMENTED = -8,
    // COORD_INVALID_BLOB_NAMES = -9,
    // COORD_INVALID_INPUT_BLOBS = -10,
    // COORD_SELECTOR_INIT_FAILD = -11,
    // COORD_TRANSFORMER_INIT_FAILD = -12,
    // COORD_CURVEFITTER_INIT_FAILD = -13,
    // COORD_INVALID_HEIGHT = -14,
    // COORD_INVALID_WIDTH = -15,
    COORD_NULL_PTR = -16,
    // COORD_INVALID_SELECTOR_TYPE = -17,
    // COORD_INVALID_TRANSFORMER_TYPE = -18,
    // COORD_INVALID_CURVEFITTER_TYPE = -19,
    // COORD_HERMITE_CUBIC_SPLINE_TO_PP_ERROR = -20,
    // COORD_HERMITE_CUBIC_SPLINE_GET_KNOTS_ERROR = -21,
    // COORD_HERMITE_CUBIC_SPLINE_GET_REG_ERROR = -22,
    // COORD_HERMITE_CUBIC_SPLINE_MAT_L1_NORM_ERROR = -23,
    // COORD_SAMPLING_INTERVAL_OUT_OF_RANGE = -24,
    // COORD_BGR_MEANS_ERROR = -25,
    // COORD_BGR_MEANS_NOT_INIT = -26,
    // COORD_INPUT_BLOB_NOT_INIT = -27,
    // COORD_OUTPUT_BLOB_NOT_INIT = -28,
    // COORD_LOAD_MODEL_ERROR = -29,
    // COORD_LOAD_LICENSE_ERROR = -30,
    // COORD_LOAD_MODEL_PARAMETERS_JSON_ERROR = -31,
    // COORD_LOAD_MODEL_ENCRYPTION_MODEL_ERROR = -32,
    // COORD_GET_UUID_FAILED = -33,
    // COORD_PREDICTOR_INIT_FAILED = -34,
    // COORD_READ_RECTIFY_PARAM_ERROR = -35,
    // COORD_GET_HOMOGRAPHY_ERROR = -36,
    // COORD_CREATE_HANDLE_ERROR = -37,
    // COORD_TRACK_FAILED = -38,
    // COORD_CANBUS_ERROR = -39,
    // COORD_CANBUS_VEHICLE_ERROR = -40,
    // COORD_CANBUS_CAN_CLIENT_ERROR = -41,
    // COORD_END_OF_FILE = -42,
    // COORD_DW_INIT_FAILED = -43,
    // COORD_VIDEO_OPEN_ERROR = -44,
    // COORD_VIDEO_CLOSE_ERROR = -45,
    // COORD_CAMERA_OPEN_ERROR = -46,
    // COORD_CAMERA_CLOSE_ERROR = -47,
    // COORD_CAMERA_READ_ERROR = -48,
    // COORD_CAMERA_RECORD_START_ERROR = -49,
    // COORD_CAMERA_RECORD_STOP_ERROR = -50,
    // COORD_INS_ERROR = -51,
    // COORD_INS_PARSER_ERROR = -52,
    // COORD_GNSS_TRANSFORMER_ERROR = -53,
    // COORD_ROUTING_ERROR = -54,
    // COORD_ROUTING_LOCALIZATION_MISS = -55,
    // COORD_ROUTING_TARGET_REACH = -56,
    // COORD_CANBUS_TIME_OUT_ERROR = -57,
    // COORD_HDMAP_ERROR = -58,
    // COORD_CALIB_CONFIG_ERROR = -59,
    // COORD_TF_TREE_INIT_ERROR = -60,
    // COORD_LOCALIZATION_ERROR = -61,
    // COORD_TIME_OUT_ERROR = -62,
    // COORD_DATA_NO_UPDATE_ERROR = -63,
    // COORD_NO_INIT_ERROR = -64,
    // COORD_DM_SCENARIO_FAILED = -65,
    // COORD_DM_TASK_FAILED = -66,
    // COORD_DM_SCENARIO_CORE_FAILED = -67,
    // COORD_NO_NEED_REROUTE = -68,
    // COORD_V2X_PARSER_ERROR = -69,
} coordStatus_t;

}  // namespace saffron
