
(cl:in-package :asdf)

(defsystem "ad_perception_msgs-msg"
  :depends-on (:roslisp-msg-protocol :roslisp-utils :std_msgs-msg
)
  :components ((:file "_package")
    (:file "AutomobileLightStatus" :depends-on ("_package_AutomobileLightStatus"))
    (:file "_package_AutomobileLightStatus" :depends-on ("_package"))
    (:file "BaseCameraAttribute" :depends-on ("_package_BaseCameraAttribute"))
    (:file "_package_BaseCameraAttribute" :depends-on ("_package"))
    (:file "Bbox2D" :depends-on ("_package_Bbox2D"))
    (:file "_package_Bbox2D" :depends-on ("_package"))
    (:file "Boundary" :depends-on ("_package_Boundary"))
    (:file "_package_Boundary" :depends-on ("_package"))
    (:file "CameraBBox2DInfo" :depends-on ("_package_CameraBBox2DInfo"))
    (:file "_package_CameraBBox2DInfo" :depends-on ("_package"))
    (:file "DepthDetPoint" :depends-on ("_package_DepthDetPoint"))
    (:file "_package_DepthDetPoint" :depends-on ("_package"))
    (:file "DirectionInfo" :depends-on ("_package_DirectionInfo"))
    (:file "_package_DirectionInfo" :depends-on ("_package"))
    (:file "Freespace" :depends-on ("_package_Freespace"))
    (:file "_package_Freespace" :depends-on ("_package"))
    (:file "LaneLine" :depends-on ("_package_LaneLine"))
    (:file "_package_LaneLine" :depends-on ("_package"))
    (:file "LidarDangerousZone" :depends-on ("_package_LidarDangerousZone"))
    (:file "_package_LidarDangerousZone" :depends-on ("_package"))
    (:file "LidarDangerousZoneFrame" :depends-on ("_package_LidarDangerousZoneFrame"))
    (:file "_package_LidarDangerousZoneFrame" :depends-on ("_package"))
    (:file "MatchedSensorObjectInfo" :depends-on ("_package_MatchedSensorObjectInfo"))
    (:file "_package_MatchedSensorObjectInfo" :depends-on ("_package"))
    (:file "Matrix3f" :depends-on ("_package_Matrix3f"))
    (:file "_package_Matrix3f" :depends-on ("_package"))
    (:file "ModelOutputFeature" :depends-on ("_package_ModelOutputFeature"))
    (:file "_package_ModelOutputFeature" :depends-on ("_package"))
    (:file "MotionInfo" :depends-on ("_package_MotionInfo"))
    (:file "_package_MotionInfo" :depends-on ("_package"))
    (:file "NonAutomobileVehicleLightStatus" :depends-on ("_package_NonAutomobileVehicleLightStatus"))
    (:file "_package_NonAutomobileVehicleLightStatus" :depends-on ("_package"))
    (:file "Object" :depends-on ("_package_Object"))
    (:file "_package_Object" :depends-on ("_package"))
    (:file "ObjectFrame" :depends-on ("_package_ObjectFrame"))
    (:file "_package_ObjectFrame" :depends-on ("_package"))
    (:file "PedestrianIntention" :depends-on ("_package_PedestrianIntention"))
    (:file "_package_PedestrianIntention" :depends-on ("_package"))
    (:file "Point2f" :depends-on ("_package_Point2f"))
    (:file "_package_Point2f" :depends-on ("_package"))
    (:file "Point3f" :depends-on ("_package_Point3f"))
    (:file "_package_Point3f" :depends-on ("_package"))
    (:file "Polygon2D" :depends-on ("_package_Polygon2D"))
    (:file "_package_Polygon2D" :depends-on ("_package"))
    (:file "Polygon3D" :depends-on ("_package_Polygon3D"))
    (:file "_package_Polygon3D" :depends-on ("_package"))
    (:file "PolygonBox" :depends-on ("_package_PolygonBox"))
    (:file "_package_PolygonBox" :depends-on ("_package"))
    (:file "RoadFrame" :depends-on ("_package_RoadFrame"))
    (:file "_package_RoadFrame" :depends-on ("_package"))
    (:file "RoadStruct" :depends-on ("_package_RoadStruct"))
    (:file "_package_RoadStruct" :depends-on ("_package"))
    (:file "SizeInfo" :depends-on ("_package_SizeInfo"))
    (:file "_package_SizeInfo" :depends-on ("_package"))
    (:file "StopLine" :depends-on ("_package_StopLine"))
    (:file "_package_StopLine" :depends-on ("_package"))
    (:file "TrafficLight" :depends-on ("_package_TrafficLight"))
    (:file "_package_TrafficLight" :depends-on ("_package"))
    (:file "TrafficLightGroup" :depends-on ("_package_TrafficLightGroup"))
    (:file "_package_TrafficLightGroup" :depends-on ("_package"))
    (:file "TrafficLightSignFrame" :depends-on ("_package_TrafficLightSignFrame"))
    (:file "_package_TrafficLightSignFrame" :depends-on ("_package"))
    (:file "TrafficSign" :depends-on ("_package_TrafficSign"))
    (:file "_package_TrafficSign" :depends-on ("_package"))
    (:file "TrafficSignal" :depends-on ("_package_TrafficSignal"))
    (:file "_package_TrafficSignal" :depends-on ("_package"))
    (:file "TurnType" :depends-on ("_package_TurnType"))
    (:file "_package_TurnType" :depends-on ("_package"))
    (:file "VecPoint2f" :depends-on ("_package_VecPoint2f"))
    (:file "_package_VecPoint2f" :depends-on ("_package"))
    (:file "Vector3d" :depends-on ("_package_Vector3d"))
    (:file "_package_Vector3d" :depends-on ("_package"))
    (:file "Vector3f" :depends-on ("_package_Vector3f"))
    (:file "_package_Vector3f" :depends-on ("_package"))
    (:file "Vector4i" :depends-on ("_package_Vector4i"))
    (:file "_package_Vector4i" :depends-on ("_package"))
  ))