#!/usr/bin/env python3

import os
import subprocess

from .path_handler import PathHandler

def get_aws_endpoint():
    current_dir = os.path.abspath(os.path.dirname(__file__))
    resource_path = PathHandler().resource_path
    target_script_path = os.path.join(resource_path, "scripts/general_binary_release/utils/get_aws_endpoint.sh")
    child = subprocess.Popen(["bash",target_script_path], stdout=subprocess.PIPE)
    endpoint_url = child.communicate()[0].decode('utf-8').strip('\n')
    rc = child.returncode
    return endpoint_url