# Find AD Map root
if(${CMAKE_CURRENT_LIST_DIR} MATCHES "/usr/local/(.*)")
    string(REGEX REPLACE "(.*)/.*" "\\1" ADMap_PATH ${CMAKE_CURRENT_LIST_DIR})
    message(STATUS "ADMap: ${ADMap_PATH}")
    list(APPEND ADMap_INCLUDE_DIRS ${ADMap_PATH}/include)
    list(APPEND ADMap_LIBRARY_DIRS ${ADMap_PATH}/lib)
else()
    message(STATUS "ADMap: develop mode")
endif()

# Set CMake Variables
set(_target "ad_map")

# Library
list(APPEND ADMap_LIBRARIES "${_target}")